﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;

namespace ClassLibrary1
{
    public class Class1
    {
        Thread m_thr;
        CH264 m_H264;
        AutoResetEvent waitHandle = new AutoResetEvent(false);
        int function;
        string m_strFileName;

        public Class1()
        {
            m_thr = new Thread(new ThreadStart(InitThread));
            m_thr.SetApartmentState(ApartmentState.MTA);
            m_thr.Start();
        }


        private void InitThread()
        {
            m_H264 = new CH264();
            if (!m_H264.Init())
            {
                //raise an error to main thread;
                return;
            }
            bool bRun = true;
            while (bRun)
            {
                waitHandle.WaitOne();
                //need some sort of critical section here and ability to raise events back to main thread
                switch (function)
                {
                    case 0:
                        m_H264.StopPreview();
                        m_H264 = null;
                        bRun = false;
                        break;
                    case 1:
                        m_H264.StartPreview();
                        break;

                    case 2:
                        m_H264.StartRecording(m_strFileName);
                        break;
                    case 3:
                        m_H264.StopPreview();
                        break;
                }
            }

        }

        public bool StartPreview()
        {

            function = 1;
            waitHandle.Set();
            //InitFFmpegThread();


            return true;
        }

        public void StopPreview()
        {
            function = 3;
            waitHandle.Set();
            return;
        }


        public bool StartRecord(string filename)
        {
            m_strFileName = filename;
            
            function = 2;
            waitHandle.Set();

            return true;
        }

    }
}
